/**
 * 
 */
var mX=0,mY=0;

var statements=[];
var divHoveringIndex=-1;
var divSrcIndex=-1;
var divDestinationIndex=-1;
var xOffset=0;
var yOffset=0;
var slotHeight=0;
var originalStatementLeft=0;
var originalStatementTop=0;
var correctIndex=0;
var wrongIndex=0;

var effectRunning=false;

function initialise(){
	var leftBorder=5;
	showAppTitle();
	
	initialiseEvents();
	showPrompt();

	codeLeftBorder=$(document).width()/2+verticalBorder;
	codeTopBorder=$(document).height()/2;
	listOkLeft=leftBorder;
	listOkTop=$("#mainArea").position().top;
	listErrorLeft=$(document).width()/2+leftBorder;
	listErrorTop=listOkTop;
	defineConditionalsArray();
	generateNewStatement();
	placeDIVs();
	initialiseEvents();
}

function initialiseEvents(){
	//mouse events
	document.addEventListener("mousedown", function(evt){
		handleMouseDown();
	});
	
	document.addEventListener("mouseup", function(evt){
		evt.stopImmediatePropagation();
		mX=evt.pageX;
	 	mY=evt.pageY;
	 	handleMouseUp();
	});
	document.addEventListener("mousemove", function(evt){
	    mX=evt.pageX;
	    mY=evt.pageY;
		handleMouseMove();
	});

	//touch events
	$("#showInfo").on("touchend",function(evt){
	    $("#showInfo").trigger("click");
	});
	
	$("#list0").on("click tap touchstart touchend",function(evt){
		$(".itemToExplain").removeClass("itemToExplain");
		if(evt.target.id!="list0"){
			handleTappedList(evt.target.id);
		}
		else{
			placeInList(correctListIndex);
		}
		evt.preventDefault();
		evt.stopImmediatePropagation();
	});
	
	$("#list1").on("click tap touchstart touchend",function(evt){
		$(".itemToExplain").removeClass("itemToExplain");
		if(evt.target.id!="list1"){
			handleTappedList(evt.target.id);
		}
		else{
			placeInList(wrongListIndex);
		}
		evt.preventDefault();
		evt.stopImmediatePropagation();
	});
	
	$("#assignmentToCheck0").on("touchend",function(evt){
		evt.preventDefault();
		evt.stopImmediatePropagation();
		$(".itemToExplain").removeClass("itemToExplain");
		
		$("#list"+wrongListIndex).css({"background-color": "#ffffff"});
		$("#list"+correctListIndex).css({"background-color": "#ffffff"});
		divSrcIndex=0;
		$("#"+statements[divSrcIndex].htmlID).addClass("tapped");
	});
	
	/*document.addEventListener("touchstart",function(evt){
		handleMouseDown();
	}, false);*/
	
	/*document.addEventListener("touchmove",function(evt){
        //evt.preventDefault();
		mX=evt.changedTouches[0].pageX;
		mY=evt.changedTouches[0].pageY;
		handleMouseMove();
    }, false);*/
}

function handleTappedList(targetID){
	$("#"+targetID).addClass("itemToExplain");
	var param=$("#"+targetID).attr("data-expl");
	showExplanation(param);

	/*statements[divSrcIndex].release();
	divDestinationIndex=listIndex;
	$("#list"+divDestinationIndex).css({"background-color": listBackcolorOnHover});
	$.each($(".tapped"),function(){
		$(this).removeClass("tapped");
	});
	handleMouseUp();*/
}

function placeInList(selectedListIndex){
	if(divSrcIndex>-1){//έλεγχος σημείου απόθεσης
		statements[divSrcIndex].release();
		divDestinationIndex=selectedListIndex;
		$("#list"+divDestinationIndex).css({"background-color": listBackcolorOnHover});
		$.each($(".tapped"),function(){
	 			$(this).removeClass("tapped");
	 		});

		handleMouseUp();
	}	
}

function handleMouseDown(){
	if(effectRunning) return;
	if(divHoveringIndex>-1){
		divSrcIndex=parseInt(divHoveringIndex);
		xOffset=statements[divSrcIndex].left-mX;
		yOffset=statements[divSrcIndex].top-mY;
		statements[divSrcIndex].grab();
	}
}

function handleMouseUp(){
	if(effectRunning) return;
	if(divSrcIndex>-1){
		statements[divSrcIndex].release();
		//1. Αν ο χρήστης αποθέτει το statement εκτός των λιστών, επιστροφή στην αρχική θέση
		if(divDestinationIndex==-1){
			divHoveringIndex=-1;
			divSrcIndex=-1;
			divDestinationIndex=-1;
			showStatements();
		}
		//2. αλλιώς τοποθέτηση σε επιλεγμένη λίστα
		else{
			var newClass="categorisationOk";
			correctIndex++;
			var itemIndex="c"+correctIndex;
			var explanationTitle="Σωστή κατηγοριοποίηση";
			if(divDestinationIndex==wrongListIndex && commandExecutable || divDestinationIndex==correctListIndex && !commandExecutable){
				correctIndex--;
				wrongIndex++;
				itemIndex="w"+wrongIndex;
				newClass="categorisationError";
				explanationTitle="Λανθασμένη κατηγοριοποίηση";
			}
			var itemToAdd=$("#assignmentToCategorise").html();
			$("#assignmentToCategorise").html("");
			var explanation="<span class=\""+newClass+"\">"+explanationTitle+":</span><br>"+$("#assignmentToCategorise").attr("data-explanation");
			var htmlToAdd="<code class='"+newClass+"' id='"+itemIndex+"' data-expl='"+explanation+"'>"+itemToAdd+"</code><br>";
			var currentList=$("#list"+divDestinationIndex).html();
			effectRunning=true;
			$("#"+statements[0].htmlID).animate({width:0, height:0, opacity:0},
					{duration: animationRate,complete: function() {
						completeEffect(htmlToAdd+currentList);
					}
			});
		}
	}
	showListPrompt();
}

function completeEffect(newHTML){
	$("#list"+divDestinationIndex).html(newHTML);
	scoreToShow=calculateScore(divDestinationIndex);
	$("#score"+divDestinationIndex).html(scoreToShow);
	divHoveringIndex=-1;
	divSrcIndex=-1;
	divDestinationIndex=-1;
	generateNewStatement();
	$("#"+statements[0].htmlID).animate({left:0, top:originalStatementTop, width:0, height:0, opacity:1},
			{complete: function() {
				showStatements();
				$("#list"+wrongListIndex).css({"background-color": "#ffffff"});
				$("#list"+correctListIndex).css({"background-color": "#ffffff"});
				$(".itemToExplain").removeClass("itemToExplain");
				
				effectRunning=false;
			}
	});
}

function calculateScore(selectedList){
	var correctEntries=$("#list"+selectedList+" .categorisationOk").length;
	var totalEntries=correctEntries+$("#list"+selectedList+" .categorisationError").length;
	var percentage=parseInt(1000*correctEntries/totalEntries)/10;
	return " - "+correctEntries+"/"+totalEntries+" ("+percentage+"%)";
	
}

function showListPrompt(){
	if(correctIndex+wrongIndex>0){
		$("#explain").html("Επιλέξτε μια καταχώρηση από τις λίστες για επεξήγηση της κατηγοριοποίησης.");
	}
}

function handleMouseMove(){
	if(effectRunning) return;
	var i=0;
	divDestinationIndex=-1;
	$("#list"+wrongListIndex).css({"background-color": "#ffffff"});
	$("#list"+correctListIndex).css({"background-color": "#ffffff"});
	if(mouseInsideList("list"+correctListIndex)){
		divDestinationIndex=correctListIndex;
		$("#list"+correctListIndex).css({"background-color": listBackcolorOnHover});
	}
	else if(mouseInsideList("list"+wrongListIndex)){
		$("#list"+wrongListIndex).css({"background-color": listBackcolorOnHover});
		divDestinationIndex=wrongListIndex;
	}
	if(divSrcIndex>-1){//μετατόπιση επιλεγμένου DIV
 		updateMovingDIV(statements[divSrcIndex]);
 	}
 	else {//έλεγχος θέσης ποντικιού ως προς τα DIVs (hovering)
 		divHoveringIndex=-1;
 		i=0;
	 	while(i<statements.length && divHoveringIndex==-1){
	 	  if (statements[i].mouseHover(mX,mY)){
	 	    xOffset=statements[i].left-mX;
	 	 	yOffset=statements[i].top-mY;
	 	 	divHoveringIndex=i;
	 	  }
	 	  else{
	 	    i++;
	 	  }
	 	}
 	}
	if(debugMode) document.getElementById("debug").innerHTML="mX="+mX+" mY="+mY+" HoverIndex="+divHoveringIndex+" SourceIndex="+divSrcIndex+" DestinationIndex="+divDestinationIndex;
}

function mouseInsideList(selectedListId){
	var listLeft=$("#"+selectedListId).offset().left;
	var listRight=listLeft+$("#"+selectedListId).width();
	var listTop=$("#"+selectedListId).offset().top;
	var listBottom=listTop+$("#"+selectedListId).height();
	var insideList=mX>listLeft;
	insideList=insideList && mX<listRight;
	insideList=insideList && mY>listTop;
	insideList=insideList && mY<listBottom;
	return insideList;
}

function handleMouseOut(){
	if(effectRunning) return;
	divHoveringIndex=-1;
}

function showExplanation(explanation){
	$("#explain").html(explanation);	
}

function updateMovingDIV(statementOnTheMove){
	statementOnTheMove.move(mX+xOffset,mY+yOffset);
}

function defineConditionalsArray(){
	var page=0,col=0,row=0;
	$.each($(".movableDIV"),function(){
		var height=parseInt($(this).outerHeight());
		slotHeight=Math.max(slotHeight,height);
	});
	var i=0;
	$.each($(".movableDIV"),function(){
		var htmlID=$(this).attr("id");
		originalStatementLeft=($(document).width()-$("#assignmentToCheck0").width())/2;
		originalStatementTop=$("#assignmentToCheck0").position().top;
		var width=$("#assignmentToCheck0").width();
		var newStatement=new statement(htmlID,codeLeftBorder,codeTopBorder,originalStatementLeft,originalStatementTop,row,col,width,slotHeight,page,animationRate);
		statements.push(newStatement);
		row++;
		i++;
	});
	placeDIVs();
}

function generateNewStatement(){
	var maxNoOfParameters=3;
	var explanation="";
	var explanation2="";
	
	commandExecutable=true;
	
	var separator=generateSeparator();
	var paramMultiplicity=parseInt(Math.random()*maxNoOfParameters)+1;
	var generator=generateParameters(separator,paramMultiplicity,0.50,0.25);
	var parameters=generator.parameters;
	var constantIncluded=generator.constantIncluded;
	var numericConstantIncluded=generator.numericConstantIncluded;
	var stringConstantIncluded=generator.stringConstantIncluded;


	var separator2=generateSeparator();
	var paramMultiplicity2=Math.random()>0.8?parseInt(Math.random()*maxNoOfParameters)+1:1;//20% πιθανότητα να δημιουργηθεί λίστα στα αριστερά του τελεστή εκχώρησης
	var generator2=generateParameters(separator2,paramMultiplicity2,0.90,0.05);
	var parameters2=generator2.parameters;
	var constantIncluded2=generator2.constantIncluded;
	//var numericConstantIncluded=generator2.numericConstantIncluded;
	//var stringConstantIncluded2=generator2.stringConstantIncluded;

	var commandID=parseInt(Math.random()*3);
	var command="";
	switch(commandID){
	case cmdInput:
		command="ΔΙΑΒΑΣΕ "+parameters;
		if(constantIncluded || paramMultiplicity>1 && separator!=" , "){
			commandExecutable=false;
			if(stringConstantIncluded && paramMultiplicity>1 && separator!=" , "){
				explanation="Μια εντολή Εισόδου δε μπορεί να τροποποιήσει την τιμή μιας αλφαριθμητικής σταθεράς.";
				explanation+="<br>Αριθμητικές πράξεις με αλφαριθμητικές σταθερές δεν είναι εκτελέσιμες στην Ψευδογλώσσα.";				
			}
			else if(numericConstantIncluded && paramMultiplicity>1 && separator!=" , "){
				explanation="Μια εντολή Εισόδου δε μπορεί να τροποποιήσει την τιμή μιας αριθμητικής σταθεράς, ούτε το αποτέλεσμα ενός αριθμητικού τελεστή.";				
			}
			else if(constantIncluded){
				explanation="Μια εντολή Εισόδου δε μπορεί να τροποποιήσει την τιμή μιας σταθεράς.";				
			}
			else if(paramMultiplicity>1 && separator!=" , "){
				explanation+=" Μια εντολή Εισόδου δε μπορεί να αλλάξει το αποτέλεσμα μιας αριθμητικής πράξης.";
			}
		}
		else{
			if(paramMultiplicity==1){
				explanation="Μια εντολή Εισόδου μπορεί να χρησιμοποιηθεί ώστε μια μεταβλητή να πάρει τιμή από το πληκτρολόγιο.";				
			}
			else if(paramMultiplicity>1 && separator==" , "){
				explanation="Μια εντολή Εισόδου μπορεί να εισάγει τιμές για πολλές μεταβλητές ταυτόχρονα.";				
			}
		}
		break;
	case cmdOutput:
		command="ΓΡΑΨΕ "+parameters;
		if(stringConstantIncluded && separator!=" , " && paramMultiplicity>1){
			commandExecutable=false;
			explanation="Στην Ψευδογλώσσα δε μπορούν να χρησιμοποιηθούν αριθμητικοί τελεστές με αλφαριθμητικές σταθερές.";
		}
		else if(separator==" , "){
			if(constantIncluded){
				explanation="Μια εντολή εξόδου μπορεί να εμφανίσει τις τιμές σταθερών.";
			}
			else{
				explanation="Μια εντολή εξόδου μπορεί να εμφανίσει τα περιεχόμενα μεταβλητών.";
			}
		}
		else if(separator!=" , "){
			if(constantIncluded){
				explanation="Μια εντολή εξόδου μπορεί να εμφανίσει την τιμή έκφρασης που περιλαμβάνει αριθμητικές σταθερές.";
			}
			else{
				explanation="Πρώτα εκτελείται ο υπολογισμός της αριθμητικής έκφρασης και κατόπιν η εντολή εξόδου εμφανίζει το αποτέλεσμα.";
			}
		}
		break;
	case cmdAssign:
		//έλεγχος ορθότητας στα δεξιά του τελεστή εκχώρησης
		if(stringConstantIncluded && paramMultiplicity>1 || paramMultiplicity>1 && separator==" , "){
			commandExecutable=false;
			if(stringConstantIncluded && paramMultiplicity>1){
				if(separator==" , "){
					explanation="Στα δεξιά του τελεστή εκχώρησης δεν επιτρέπεται λίστα παραμέτρων, αφού δεν είναι ξεκάθαρο ποια (μοναδική) τιμή θα πρέπει να εκχωρηθεί.";
				}
				else{
					explanation="Στην ψευδογλώσσα δεν ορίζονται πράξεις με αλφαριθμητικά.";	
				}
			}
			else if(separator==" , "){
				explanation="Στα δεξιά του τελεστή εκχώρησης δεν επιτρέπεται λίστα τιμών, αφού δεν είναι ξεκάθαρο ποια (μοναδική) τιμή θα πρέπει να εκχωρηθεί.";
			}
		}
		//έλεγχος ορθότητας στα αριστερά του τελεστή εκχώρησης
		if(constantIncluded2 || paramMultiplicity2>1){
			commandExecutable=false;
			if(paramMultiplicity2>1){
				if(separator2==" , "){
					explanation2="Ο τελεστής εκχώρησης δε μπορεί να δώσει τιμή ταυτόχρονα σε περισσότερους από έναν αποδέκτες.";
					if(constantIncluded2){
						explanation2+="<br>Ο αποδέκτης τιμής δε μπορεί να είναι σταθερά.";
					}
				}
				else{
					explanation2="Δεν είναι δυνατό να εκχωρηθεί τιμή σε αποτέλεσμα μιας πράξης.";	
					if(constantIncluded2){
						explanation2+="<br>Ο αποδέκτης τιμής δε μπορεί να είναι σταθερά.";
					}
				}
			}
			else if(constantIncluded2){
				explanation2="Ο τελεστής εκχώρησης δε μπορεί να τροποποιήσει την τιμή μιας σταθεράς.";
			}
		}
		if(commandExecutable){//όλα ok
			if(constantIncluded && paramMultiplicity==1){
				explanation="Επιτρέπεται η εκχώρηση τιμής μιας σταθεράς σε μία μεταβλητή.";			
			}
			else if(paramMultiplicity>1){
				explanation="Πρώτα αποτιμάται η έκφραση, δηλ. υπολογίζεται η τιμή της, και κατόπιν εκχωρείται το αποτέλεσμα στη μεταβλητή που υπάρχει στα αριστερά του τελεστή εκχώρησης.";			
			}
			else{
				explanation="Επιτρέπεται η αντιγραφή της τιμής μιας μεταβλητής σε μια άλλη.";				
			}
		}
		command=parameters2+" <- "+parameters;
		break;
	}
	$("#assignmentToCategorise").html(command);
	var explanationToShow="";
	if(explanation!="") explanationToShow=explanation;
	if(explanation2!=""){
		if(explanation!="")explanationToShow+="<br>";
		explanationToShow+=explanation2;
	}
	$("#assignmentToCategorise").attr("data-explanation",explanationToShow);
}

function generateSeparator(){ 
	var separator=" , ";
	if(Math.random()<0.5){// 50% πιθανότητα να έχουμε έκφραση
		separator=" + ";
	}
	return separator;
}


function generateParameters(separator,paramMultiplicity,nameThreshold,constantThreshold){
	var noOfOperators=5;
	var quotations="";
	var separatorToUse="";
	var parameters="";
	var constantIncluded=false;
	var numericConstantIncluded=false;
	var stringConstantIncluded=false;

	
	for(var i=0;i<paramMultiplicity;i++){
		if(i<paramMultiplicity-1){
			if(separator==" , "){
				separatorToUse=separator;
			}
			else{
				var operatorSelector=0;
				var previousSelector=-1;
				do{
					operatorSelector=parseInt(Math.random()*noOfOperators);
				}while(operatorSelector==previousSelector);
				switch(operatorSelector){
				case 0:
					separatorToUse=" + ";
					break;
				case 1:
					separatorToUse=" - ";
					break;
				case 2:
					separatorToUse=" * ";
					break;
				case 3:
					separatorToUse=" / ";
					break;
				case 4:
					separatorToUse=" ^ ";
					break;
				}
			}
		}
		else{
			separatorToUse="";
		}
		var newParam="";
		if(Math.random()<nameThreshold){// nameThreshold ΠΙΘΑΝΟΤΗΤΑ ΝΑ ΔΗΜΙΟΥΡΓΗΘΕΙ ΟΝΟΜΑ...
			if(Math.random()<0.5){// το οποίο τις μισές φορές θα είναι μονογράμματη μεταβλητή...
				do{
				newParam=String.fromCharCode(parseInt(Math.random()*24)+945);
				}while(newParam=="ς");
			}
			else{//...και τις υπόλοιπες θα είναι σύνηθες όνομα μεταβλητής
				var availableNames=parseInt(Math.random()*commonNames.length);
				newParam=commonNames[availableNames];
			}			
			if(Math.random()<constantThreshold){//constantThreshold πιθανότητα το όνομα να μετατραπεί σε αλφαριθμητική σταθερά
				stringConstantIncluded=true;
				constantIncluded=true;
				quotations="\"";
			}
			else{
				quotations="";
			}
		}
		else{//... ΚΑΙ 1-nameThreshold ΠΙΘΑΝΟΤΗΤΑ ΝΑ ΔΗΜΙΟΥΡΓΗΘΕΙ ΑΚΕΡΑΙΑ ΔΙΨΗΦΙΑ ΣΤΑΘΕΡΑ
			newParam=parseInt(Math.random()*100)+1;
			numericConstantIncluded=true;
			constantIncluded=true;
		}
		parameters+=quotations+newParam+quotations+separatorToUse;
	}
	return {
		parameters: parameters,
		constantIncluded: constantIncluded,
		numericConstantIncluded: numericConstantIncluded,
		stringConstantIncluded: stringConstantIncluded
	};
}

function placeDIVs(){
	$("#correctAssignments").css({left: listOkLeft, top: listOkTop});
	$("#correctAssignments").width(0.48*$(document).width());
	$("#wrongAssignments").css({left: listErrorLeft, top: listErrorTop});
	$("#wrongAssignments").width(0.48*$(document).width());
	showStatements();
}

function showStatements(){
	for(var i=0;i<statements.length;i++){
		$("#assignmentToCheck"+i).show();
		statements[i].move(originalStatementLeft,originalStatementTop);
	}
}

function showPrompt(){
	var msg="Αν πιστεύεις ότι η παρακάτω εντολή είναι εκτελέσιμη από τον υπολογιστή τοποθέτησέ την στην αριστερή στήλη, διαφορετικά τοποθέτησέ την στη δεξιά.";
    $("#prompt").html(msg);
}